diff --git a/test/unit/stages/review/fallback_coverage_test.rb b/test/unit/stages/review/fallback_coverage_test.rb
new file mode 100644
index 00000000..2c4275a5
--- /dev/null
+++ b/test/unit/stages/review/fallback_coverage_test.rb
@@ -0,0 +1,358 @@
+require "test_helper"
+require "hive/stages/review"
+
+class ReviewFallbackCoverageTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_candidate_is_only_the_exact_missing_stop_timeout_with_evidence
+    exact = fallback_result
+    assert Hive::Stages::Review.claude_completion_fallback_candidate?(exact)
+
+    refute Hive::Stages::Review.claude_completion_fallback_candidate?(
+      exact.merge(error_message: "another timeout")
+    )
+    refute Hive::Stages::Review.claude_completion_fallback_candidate?(
+      exact.merge(status: :error)
+    )
+    refute Hive::Stages::Review.claude_completion_fallback_candidate?(
+      exact.reject { |key, _| key == :completion_evidence }
+    )
+  end
+
+  def test_phase_facts_accept_commit_dirty_and_whole_pass_no_change_evidence
+    with_context do |ctx|
+      write_artifacts(ctx, "- [x] apply fix\n")
+      accepted = Hive::Stages::Review::AcceptedFindings.new(text: "apply", count: 1)
+
+      committed = nil
+      with_replaced_singleton_method(Hive::Stages::Review, :forward_commit?, ->(*) { true }) do
+        committed = Hive::Stages::Review.completion_fallback_phase_facts(
+          ctx,
+          accepted_findings: accepted,
+          reviewer_paths: [ reviewer_path(ctx) ],
+          before_fix_head: "aaa",
+          after_fix_head: "bbb",
+          post_fix_status: :clean
+        )
+      end
+      assert committed.fetch(:facts).values.all?
+      assert_equal "commit_transition:aaa..bbb", committed.fetch(:basis)
+
+      dirty = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [ reviewer_path(ctx) ],
+        before_fix_head: "aaa",
+        after_fix_head: "aaa",
+        post_fix_status: :dirty
+      )
+      assert dirty.fetch(:facts).values.all?
+      assert_equal "dirty_worktree", dirty.fetch(:basis)
+
+      File.write(
+        reviewer_path(ctx),
+        "## High\n\n- [x] RESOLVED/NO-FIX: already correct\n"
+      )
+      File.write(escalations_path(ctx), <<~MD)
+        # Escalations for pass 01
+
+        ## Round 1
+
+        ### Q1. Is a code change required?
+        Source: stub-reviewer-01.md
+        Finding: already correct
+        ### A1.
+        No code change is required.
+      MD
+      no_change = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [ reviewer_path(ctx) ],
+        before_fix_head: "aaa",
+        after_fix_head: "aaa",
+        post_fix_status: :clean
+      )
+      assert no_change.fetch(:facts).values.all?
+      assert_equal "whole_pass_no_change", no_change.fetch(:basis)
+    end
+  end
+
+  def test_forward_commit_requires_the_starting_head_to_be_an_ancestor
+    with_tmp_git_repo do |dir|
+      original = run!("git", "-C", dir, "rev-parse", "HEAD").strip
+      File.write(File.join(dir, "forward.txt"), "forward\n")
+      run!("git", "-C", dir, "add", "forward.txt")
+      run!("git", "-C", dir, "commit", "-m", "forward", "--quiet")
+      descendant = run!("git", "-C", dir, "rev-parse", "HEAD").strip
+
+      assert Hive::Stages::Review.forward_commit?(dir, original, descendant)
+      refute Hive::Stages::Review.forward_commit?(dir, descendant, original)
+      refute Hive::Stages::Review.forward_commit?(dir, original, original)
+    end
+  end
+
+  def test_phase_facts_reject_mixed_no_change_and_each_artifact_failure
+    with_context do |ctx|
+      accepted = Hive::Stages::Review::AcceptedFindings.new(text: "two", count: 2)
+      write_artifacts(
+        ctx,
+        "- [x] AUTO-FIX: first\n" \
+          "- [x] AUTO-FIX: second\n" \
+          "- [x] RESOLVED/NO-FIX: unrelated disposition\n"
+      )
+
+      mixed = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [ reviewer_path(ctx) ],
+        before_fix_head: "aaa",
+        after_fix_head: "aaa",
+        post_fix_status: :clean
+      )
+      assert_equal false, mixed.fetch(:facts).fetch(:commit_or_no_change)
+
+      File.write(escalations_path(ctx), "# Escalations for pass 01\n\n- [ ] unresolved\n")
+      unresolved = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [ reviewer_path(ctx) ],
+        before_fix_head: "aaa",
+        after_fix_head: "bbb",
+        post_fix_status: :clean
+      )
+      assert_equal false, unresolved.fetch(:facts).fetch(:no_unresolved_escalation)
+
+      File.write(
+        File.join(ctx.task_folder, "reviews", "errors-01.md"),
+        "reviewer process crashed"
+      )
+      missing_output = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [ reviewer_path(ctx) ],
+        before_fix_head: "aaa",
+        after_fix_head: "bbb",
+        post_fix_status: :clean
+      )
+      assert_equal false, missing_output.fetch(:facts).fetch(:no_missing_output)
+
+      unreadable = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [ reviewer_path(ctx) ],
+        before_fix_head: "aaa",
+        after_fix_head: "bbb",
+        post_fix_status: [ :status_failed, "git failed" ]
+      )
+      assert_equal false, unreadable.fetch(:facts).fetch(:worktree_readable)
+
+      File.delete(escalations_path(ctx))
+      missing = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [ reviewer_path(ctx) ],
+        before_fix_head: "aaa",
+        after_fix_head: "bbb",
+        post_fix_status: :clean
+      )
+      assert_equal false, missing.fetch(:facts).fetch(:artifacts_present)
+      assert_equal false, missing.fetch(:facts).fetch(:artifacts_parseable)
+    end
+  end
+
+  def test_phase_facts_require_every_configured_reviewer_output
+    with_context do |ctx|
+      write_artifacts(ctx, "- [x] AUTO-FIX: apply fix\n")
+      accepted = Hive::Stages::Review::AcceptedFindings.new(text: "apply fix", count: 1)
+
+      snapshot = Hive::Stages::Review.completion_fallback_phase_facts(
+        ctx,
+        accepted_findings: accepted,
+        reviewer_paths: [
+          reviewer_path(ctx),
+          reviewer_path(ctx, "missing-reviewer")
+        ],
+        before_fix_head: "aaa",
+        after_fix_head: "bbb",
+        post_fix_status: :clean
+      )
+
+      assert_equal false, snapshot.fetch(:facts).fetch(:artifacts_present)
+      assert_equal false, snapshot.fetch(:facts).fetch(:artifacts_parseable)
+    end
+  end
+
+  def test_artifact_parsers_reject_arbitrary_text_and_accept_structured_documents
+    assert Hive::Stages::Review.reviewer_artifact_parseable?(
+      "## High\nNo findings.\n\n## Medium\n- [x] AUTO-FIX: apply fix\n"
+    )
+    refute Hive::Stages::Review.reviewer_artifact_parseable?("## High\n")
+    refute Hive::Stages::Review.reviewer_artifact_parseable?("## High\n- [x] \n")
+    refute Hive::Stages::Review.reviewer_artifact_parseable?("review completed successfully\n")
+
+    with_context do |ctx|
+      path = escalations_path(ctx)
+      File.write(path, "# Escalations for pass 01\n\nnonsense\n")
+      refute Hive::Stages::Review.escalation_artifact_parseable?(
+        ctx, path, File.binread(path)
+      )
+
+      File.write(path, <<~MD)
+        # Escalations for pass 01
+
+        ## Round 1
+
+        ### Q1. Apply the fix?
+        Source: stub-reviewer-01.md
+        ### A1.
+        Yes.
+      MD
+      assert Hive::Stages::Review.escalation_artifact_parseable?(
+        ctx, path, File.binread(path)
+      )
+    end
+  end
+
+  def test_no_change_dispositions_must_match_each_accepted_finding
+    with_context do |ctx|
+      write_artifacts(
+        ctx,
+        "- [x] AUTO-FIX: lib/one.rb leaks stale state: apply fix\n" \
+          "- [x] RESOLVED/NO-FIX: lib/other.rb has unrelated issue: already correct\n"
+      )
+      accepted = Hive::Stages::Review::AcceptedFindings.new(text: "one", count: 1)
+
+      refute Hive::Stages::Review.whole_pass_no_change?(
+        ctx,
+        [ reviewer_path(ctx) ],
+        accepted
+      )
+    end
+  end
+
+  def test_no_change_disposition_cannot_launder_a_still_accepted_duplicate
+    with_context do |ctx|
+      write_artifacts(
+        ctx,
+        "- [x] AUTO-FIX: lib/one.rb leaks stale state: apply fix\n"
+      )
+      File.write(
+        reviewer_path(ctx, "duplicate-reviewer"),
+        "## High\n\n" \
+          "- [x] RESOLVED/NO-FIX: lib/one.rb leaks stale state: apply fix\n"
+      )
+      accepted = Hive::Stages::Review::AcceptedFindings.new(text: "one", count: 1)
+
+      refute Hive::Stages::Review.whole_pass_no_change?(
+        ctx,
+        [ reviewer_path(ctx), reviewer_path(ctx, "duplicate-reviewer") ],
+        accepted
+      )
+    end
+  end
+
+  def test_truncated_audit_record_cannot_authorize_fallback
+    with_context do |ctx|
+      write_artifacts(ctx, "- [x] AUTO-FIX: apply fix\n")
+      File.write(File.join(ctx.task_folder, "task.md"), "---\nslug: fallback-test\n---\n")
+      task = Struct.new(:folder, :slug, :state_file).new(
+        ctx.task_folder,
+        "fallback-test",
+        File.join(ctx.task_folder, "task.md")
+      )
+      accepted = Hive::Stages::Review::AcceptedFindings.new(text: "apply fix", count: 1)
+      long_root = "/#{'very-long-segment/' * 100}"
+      result = {
+        status: :timeout,
+        error_message: "claude stop hook did not signal completion",
+        completion_evidence: complete_evidence.merge(
+          expected_signal_paths: {
+            sentinel: "#{long_root}.done",
+            result: "#{long_root}result.json"
+          }
+        )
+      }
+
+      accepted_fallback = nil
+      with_replaced_singleton_method(Hive::Stages::Review, :forward_commit?, ->(*) { true }) do
+        accepted_fallback = Hive::Stages::Review.suppress_claude_completion_timeout?(
+          task: task,
+          ctx: ctx,
+          fix_result: result,
+          accepted_findings: accepted,
+          reviewer_paths: [ reviewer_path(ctx) ],
+          before_fix_head: "aaa",
+          after_fix_head: "bbb",
+          post_fix_status: :clean
+        )
+      end
+
+      assert_equal false, accepted_fallback
+      event = File.readlines(File.join(ctx.task_folder, "events.jsonl"))
+                  .map { |line| JSON.parse(line) }
+                  .find { |item| item["event_type"] == "claude_completion_fallback" }
+      assert event.fetch("message").end_with?(Hive::Events::MESSAGE_TRUNCATION_SUFFIX)
+    end
+  end
+
+  private
+
+  def fallback_result
+    {
+      status: :timeout,
+      error_message: "claude stop hook did not signal completion",
+      completion_evidence: {
+        normal_completion: true
+      }
+    }
+  end
+
+  def complete_evidence
+    {
+      reason: :busy_to_idle,
+      normal_completion: true,
+      launch_mode: :tmux,
+      work_started: true,
+      pane_idle: true,
+      session_alive: true,
+      tmux_readable: true,
+      provider_limit: false,
+      sentinel_present: false,
+      result_present: false,
+      session_error: nil,
+      process_state: :alive,
+      pid: 12_345,
+      session_name: "fallback-session",
+      exit_code: nil
+    }
+  end
+
+  def with_context
+    with_tmp_dir do |dir|
+      ctx = Hive::Stages::Review::Context.new(
+        worktree_path: dir,
+        task_folder: dir,
+        default_branch: "main",
+        pass: 1
+      )
+      FileUtils.mkdir_p(File.join(dir, "reviews"))
+      yield ctx
+    end
+  end
+
+  def write_artifacts(ctx, reviewer_body)
+    File.write(
+      reviewer_path(ctx),
+      "## High\n\n#{reviewer_body}"
+    )
+    File.write(escalations_path(ctx), "# Escalations for pass 01\n\n_All clean._\n")
+  end
+
+  def escalations_path(ctx)
+    File.join(ctx.task_folder, "reviews", "escalations-01.md")
+  end
+
+  def reviewer_path(ctx, basename = "stub-reviewer")
+    File.join(ctx.task_folder, "reviews", "#{basename}-01.md")
+  end
+end
diff --git a/test/unit/stop_hook_installer_test.rb b/test/unit/stop_hook_installer_test.rb
index 71b2a57a..dca3b9bc 100644
--- a/test/unit/stop_hook_installer_test.rb
+++ b/test/unit/stop_hook_installer_test.rb
@@ -3,6 +3,7 @@ require "json"
 require "open3"
 require "shellwords"
 require "tmpdir"
+require "hive/claude_launcher"
 require "hive/stop_hook_installer"
 
 class StopHookInstallerTest < Minitest::Test
@@ -70,6 +71,36 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_installer_and_launcher_share_the_task_folder_signal_contract
+    with_tmp_dir do |stage_dir|
+      Dir.mktmpdir do |worktree_dir|
+        task = Struct.new(:folder).new(stage_dir)
+        paths = Hive::StopHookInstaller.install(
+          stage_dir: stage_dir,
+          extra_dirs: [ worktree_dir ]
+        )
+
+        assert_equal(
+          [ File.join(stage_dir, ".claude", "settings.json"),
+            File.join(worktree_dir, ".claude", "settings.json") ],
+          paths
+        )
+        assert_equal File.join(stage_dir, ".done"), Hive::ClaudeLauncher.done_path(task)
+        assert_equal File.join(stage_dir, "result.json"), Hive::ClaudeLauncher.result_path(task)
+
+        paths.each do |path|
+          command = JSON.parse(File.read(path))
+                        .fetch("hooks").fetch("Stop").first
+                        .fetch("hooks").first.fetch("command")
+          argv = Shellwords.split(command)
+
+          assert_equal "HIVE_TASK_STAGE_DIR=#{stage_dir}", argv.fetch(0)
+          assert_equal HOOK, argv.fetch(1)
+        end
+      end
+    end
+  end
+
   def test_install_skips_extra_dir_equal_to_stage_dir
     with_tmp_dir do |dir|
       paths = Hive::StopHookInstaller.install(stage_dir: dir, extra_dirs: [ dir ])
@@ -137,6 +168,19 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_stop_hook_writes_forensic_payload_before_done_for_empty_stdin
+    with_tmp_dir do |dir|
+      out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "")
+      result_path = Hive::ClaudeLauncher.result_path(Struct.new(:folder).new(dir))
+      done_path = Hive::ClaudeLauncher.done_path(Struct.new(:folder).new(dir))
+
+      assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
+      assert_equal({ "hive_stop_hook" => "empty_stdin" }, JSON.parse(File.read(result_path)))
+      assert_operator File.mtime(result_path), :<=, File.mtime(done_path),
+                      "result.json must become visible no later than .done"
+    end
+  end
+
   def test_stop_hook_requires_stage_dir_env
     # Scrub HIVE_TASK_STAGE_DIR from the child env so the test is hermetic even
     # when the surrounding shell exports it (e.g. under the review harness);
